Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -1039,223 +1058,257 @@
        IMPLICIT NONE
 
-       INTEGER  ::  i, i_omp, j, k, tn
-       LOGICAL  ::  degraded_l, degraded_s
-       REAL     ::  gu, gv, flux_d, diss_d, u_comp, v_comp_l, w_comp
+       INTEGER  ::  i, i_omp, j, k, tn, k_ppp, k_pp, k_mm
+       REAL     ::  gu, gv, flux_d, diss_d, u_comp, v_comp_l, w_comp, div
        REAL, DIMENSION(nzb:nzt+1)  ::  flux_t, diss_t, flux_n,                &
                                        diss_n, flux_r, diss_r, v_comp
-                                       
-       degraded_l = .FALSE.
-       degraded_s = .FALSE.
-      
+
        gu = 2.0 * u_gtrans
        gv = 2.0 * v_gtrans
-       
-       IF ( boundary_flags(j,i) /= 0 )  THEN
+
 !       
-!--       Degrade the order for Dirichlet bc. at the outflow boundary
-          SELECT CASE ( boundary_flags(j,i) )
-          
-             CASE ( 1 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                   flux_r(k) = u_comp * (                                     &
-                               7.0 * (v(k,j,i+1) + v(k,j,i)    )              &
-                             -       ( v(k,j,i+2) + v(k,j,i-1) ) ) * adv_mom_3
-                   diss_r(k) = - ABS( u_comp ) * (                            &
-                               3.0 * ( v(k,j,i+1) - v(k,j,i)   )              &
-                             -       ( v(k,j,i+2) - v(k,j,i-1) ) ) * adv_mom_3
-                ENDDO
-                
-             CASE ( 2 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                   flux_r(k) = u_comp * ( v(k,j,i+1) + v(k,j,i) ) * 0.25 
-                   diss_r(k) = diss_2nd( v(k,j,i+1), v(k,j,i+1), v(k,j,i),    &
-                                         v(k,j,i-1), v(k,j,i-2), u_comp,      &
-                                         0.25, ddx )
-                ENDDO
-                
-             CASE ( 3 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                   flux_n(k) = ( v_comp(k)- gv ) * (                          &
-                               7.0 * ( v(k,j+1,i) + v(k,j,i)   )              &
-                             -       ( v(k,j+2,i) + v(k,j-1,i) ) ) * adv_mom_3
-                   diss_n(k) = - ABS( v_comp(k) - gv ) * (                    &
-                               3.0 * ( v(k,j+1,i) - v(k,j,i)   )              &
-                             -       ( v(k,j+2,i) - v(k,j-1,i) ) ) * adv_mom_3
-                ENDDO
-                
-             CASE ( 4 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                   flux_n(k) = ( v_comp(k) - gv ) *                           &
-                               ( v(k,j+1,i) + v(k,j,i) ) * 0.25 
-                   diss_n(k) = diss_2nd( v(k,j+1,i), v(k,j+1,i), v(k,j,i),    &
-                                         v(k,j-1,i), v(k,j-2,i), v_comp(k),   &
-                                         0.25, ddy )
-                ENDDO
-                
-             CASE ( 5 )
-                DO  k = nzb_w_inner(j,i)+1, nzt
-                   u_comp    = u(k,j-1,i) + u(k,j,i) - gu 
-                   flux_r(k) = u_comp * (                                     &
-                               7.0 * ( v(k,j,i+1) + v(k,j,i)   )              &
-                             -       ( v(k,j,i+2) + v(k,j,i-1) ) ) * adv_mom_3
-                   diss_r(k) = - ABS( u_comp ) * (                            &
-                               3.0 * ( w(k,j,i+1) - w(k,j,i)   )              &
-                             -       ( v(k,j,i+2) - v(k,j,i-1) ) ) * adv_mom_3
-                ENDDO
-                
-             CASE ( 6 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   u_comp        = u(k,j-1,i) + u(k,j,i) - gu
-                   flux_l_v(k,j,tn) = u_comp * ( v(k,j,i) + v(k,j,i-1) ) * 0.25
-                   diss_l_v(k,j,tn) = diss_2nd( v(k,j,i+2), v(k,j,i+1), v(k,j,i),&
-                                             v(k,j,i-1), v(k,j,i-1), u_comp,  &
-                                             0.25, ddx )
-                                  
-                   u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                   flux_r(k) = u_comp * (                                     &
-                               7.0 * ( v(k,j,i+1) + v(k,j,i)   )              &
-                             -       ( v(k,j,i+2) + v(k,j,i-1) ) ) * adv_mom_3
-                   diss_r(k) = - ABS( u_comp ) * (                            &
-                               3.0 * ( v(k,j,i+1) - v(k,j,i)   )              &
-                             -       ( v(k,j,i+2) - v(k,j,i-1) ) ) * adv_mom_3 
-                ENDDO
-                degraded_l = .TRUE.
-                
-             CASE ( 7 )
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   v_comp(k)   = v(k,j,i) + v(k,j-1,i) - gv
-                   flux_s_v(k,tn) = v_comp(k) * ( v(k,j,i) + v(k,j-1,i) ) * 0.25
-                   diss_s_v(k,tn) = diss_2nd( v(k,j+2,i), v(k,j+1,i), v(k,j,i),  &
-                                           v(k,j-1,i), v(k,j-1,i), v_comp(k), &
-                                           0.25, ddy )
-                                  
-                   v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                   flux_n(k) = ( v_comp(k) - gv ) * (                         &
-                               7.0 * ( v(k,j+1,i) + v(k,j,i)   )              &
-                             -       ( v(k,j+2,i) + v(k,j-1,i) ) ) * adv_mom_3
-                   diss_n(k) = - ABS( v_comp(k) - gv ) * (                    &
-                               3.0 * ( v(k,j+1,i) - v(k,j,i)   )              &
-                             -       ( v(k,j+2,i) - v(k,j-1,i) ) ) * adv_mom_3
-                ENDDO
-                degraded_s = .TRUE.
-                
-              CASE DEFAULT
-              
-          END SELECT
-!          
-!--       Compute the crosswise 5th order fluxes at the outflow
-          IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2  .OR.   &
-               boundary_flags(j,i) == 5 .OR. boundary_flags(j,i) == 6 )  THEN
-          
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                flux_n(k) = ( v_comp(k) - gv ) * (                            &
-                            37.0 * ( v(k,j+1,i) + v(k,j,i)   )                &
-                          -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )                &
-                          +        ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
-                diss_n(k) = - ABS( v_comp(k) - gv ) * (                       &
-                             10.0 * ( v(k,j+1,i) - v(k,j,i)   )               &
-                           -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )               &
-                           +        ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
-              ENDDO
-              
-          ELSE
-          
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                flux_r(k) = u_comp * (                                        &
-                            37.0 * ( v(k,j,i+1) + v(k,j,i)   )                &
-                          -  8.0 * ( v(k,j,i+2) + v(k,j,i-1) )                &
-                          +        ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
-                diss_r(k) = - ABS( u_comp ) * (                               &
-                            10.0 * ( v(k,j,i+1) - v(k,j,i)   )                &
-                          -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )                &
-                          +        ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
-             ENDDO
-             
-          ENDIF
-         
-       ELSE
-!       
-!--       Compute the fifth order fluxes for the interior of PE domain.                 
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-             flux_r(k) = u_comp * (                                           &
-                         37.0 * ( v(k,j,i+1) + v(k,j,i)   )                   &
-                       -  8.0 * ( v(k,j,i+2) + v(k,j,i-1) )                   &
-                       +        ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
-             diss_r(k) = - ABS( u_comp ) * (                                  &
-                         10.0 * ( v(k,j,i+1) - v(k,j,i) )                     &
-                       -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )                   &
-                       +        ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
-
-             v_comp(k) = v(k,j+1,i) + v(k,j,i)
-             flux_n(k) = ( v_comp(k) - gv ) * (                               &
-                         37.0 * ( v(k,j+1,i) + v(k,j,i)   )                   &
-                       -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )                   &
-                         +      ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
-             diss_n(k) = - ABS( v_comp(k) - gv ) * (                          &
-                         10.0 * ( v(k,j+1,i) - v(k,j,i)   )                   &
-                       -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )                   &
-                       +        ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
-          ENDDO 
-          
-       ENDIF
-!       
-!--    Compute left- and southside fluxes for the respective boundary       
-       IF ( i == i_omp  .AND.  .NOT. degraded_l )  THEN
-
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             u_comp        = u(k,j-1,i) + u(k,j,i) - gu
-             flux_l_v(k,j,tn) = u_comp * (                                       &
+!--    Compute leftside fluxes for the respective boundary.
+       IF ( i == i_omp )  THEN
+
+          DO  k = nzb+1, nzb_max
+
+             u_comp           = u(k,j-1,i) + u(k,j,i) - gu
+             flux_l_v(k,j,tn) = u_comp * (                                     &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( v(k,j,i)   + v(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( v(k,j,i+1) + v(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( v(k,j,i+2) + v(k,j,i-3) )               &
+                                         )
+
+              diss_l_v(k,j,tn) = - ABS( u_comp ) * (                           &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( v(k,j,i)   - v(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( v(k,j,i+1) - v(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( v(k,j,i+2) - v(k,j,i-3) )               &
+                                                   )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp           = u(k,j-1,i) + u(k,j,i) - gu
+             flux_l_v(k,j,tn) = u_comp * (                                    &
                              37.0 * ( v(k,j,i) + v(k,j,i-1)   )               &
                            -  8.0 * ( v(k,j,i+1) + v(k,j,i-2) )               &
                            +        ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
-             diss_l_v(k,j,tn) = - ABS( u_comp ) * (                              &
+             diss_l_v(k,j,tn) = - ABS( u_comp ) * (                           &
                              10.0 * ( v(k,j,i) - v(k,j,i-1)   )               &
                            -  5.0 * ( v(k,j,i+1) - v(k,j,i-2) )               &
                            +        ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+
           ENDDO
           
        ENDIF
+!
+!--    Compute southside fluxes for the respective boundary.
+       IF ( j == nysv )  THEN
        
-       IF ( j == nysv  .AND.  .NOT. degraded_s )  THEN
-       
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             v_comp_l    = v(k,j,i) + v(k,j-1,i) - gv
-             flux_s_v(k,tn) = v_comp_l * (                                       &
+          DO  k = nzb+1, nzb_max
+
+             v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
+             flux_s_v(k,tn) = v_comp_l * (                                    &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( v(k,j,i)   + v(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( v(k,j+1,i) + v(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( v(k,j+2,i) + v(k,j-3,i) )              &
+                                         )
+
+             diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( v(k,j,i)   - v(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( v(k,j+1,i) - v(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( v(k,j+2,i) - v(k,j-3,i) )              &
+                                                 )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
+             flux_s_v(k,tn) = v_comp_l * (                                    &
                            37.0 * ( v(k,j,i) + v(k,j-1,i)   )                 &
                          -  8.0 * ( v(k,j+1,i) + v(k,j-2,i) )                 &
                          +        ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
-             diss_s_v(k,tn) = - ABS( v_comp_l ) * (                              &
+             diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
                            10.0 * ( v(k,j,i) - v(k,j-1,i)   )                 &
                          -  5.0 * ( v(k,j+1,i) - v(k,j-2,i) )                 &
                          +        ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+
           ENDDO
           
        ENDIF
-!       
-!--    Now compute the tendency terms for the horizontal parts.         
-       DO  k = nzb_v_inner(j,i)+1, nzt                 
+
+       flux_t(0) = 0.0
+       diss_t(0) = 0.0
+       flux_d    = 0.0
+       diss_d    = 0.0
+!
+!--    Now compute the fluxes and tendency terms for the horizontal and
+!--    verical parts.
+       DO  k = nzb+1, nzb_max
+
+          u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp * (                                             &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j,i+1) + v(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j,i+2) + v(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j,i+3) + v(k,j,i-2) )                 &
+                               )
+
+          diss_r(k) = - ABS( u_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j,i+1) - v(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j,i+2) - v(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j,i+3) - v(k,j,i-2) )                 &
+                                        )
+
+          v_comp(k) = v(k,j+1,i) + v(k,j,i)
+          flux_n(k) = ( v_comp(k) - gv ) * (                                 &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j+1,i) + v(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j+2,i) + v(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j+3,i) + v(k,j-2,i) )                 &
+                               )
+
+          diss_n(k) = - ABS( v_comp(k) - gv ) * (                            &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j+1,i) - v(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j+2,i) - v(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j+3,i) - v(k,j-2,i) )                 &
+                                        )
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),26,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),24,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),26,1)
+
+          w_comp    = w(k,j-1,i) + w(k,j,i)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   + v(k,j,i)    )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  + v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) + v(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   - v(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  - v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) - v(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography. 
+          div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx      &
+               +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy      &
+               +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) ) ) * ddzw(k)  &
+                ) * 0.5
+
           tend(k,j,i) = tend(k,j,i) - (                                       &
                          ( flux_r(k) + diss_r(k)                              &
-                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx            &
+                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx      &
                        + ( flux_n(k) + diss_n(k)                              &
-                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy     )
-        
+                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
+                       + ( flux_t(k) + diss_t(k)                              &
+                       -   flux_d    - diss_d                    ) * ddzw(k)  &
+                                      ) + v(k,j,i) * div
+
            flux_l_v(k,j,tn) = flux_r(k)
            diss_l_v(k,j,tn) = diss_r(k)
            flux_s_v(k,tn)   = flux_n(k)
            diss_s_v(k,tn)   = diss_n(k)
-
-!
-!--        Statistical Evaluation of v'v'. The factor has to be applied for 
+           flux_d           = flux_t(k)
+           diss_d           = diss_t(k)
+
+!
+!--        Statistical Evaluation of v'v'. The factor has to be applied for
 !--        right evaluation when gallilei_trans = .T. .
-
-           sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                                &
+           sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                          &
              + ( flux_n(k)                                                    &
              * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                             &
